#include <string>

#include <itksys/Directory.hxx>
#include <itksys/SystemTools.hxx>

int main(int argc, char * argv[])
{
    std::string FolderToParse = "./TopFolder";
    
    // make an absolute path from whatever is passed in
    std::string AbsolutePath =
        itksys::SystemTools::CollapseFullPath(FolderToParse);

    // work in Unix filename conventions
    itksys::SystemTools::ConvertToUnixSlashes(AbsolutePath);
    
    itksys::Directory directory;
    
    directory.Load(AbsolutePath);
    
    for (unsigned int file_idx = 0; file_idx < numFiles; file_idx++)
    {
       std::string CurrFile = directory.GetFile(file_idx);
       std::string FullFilePath = AbsolutePath + "/" + CurrFile;
       if (CurrFile == "." || CurrFile == "..")//if current folder or parent, continue
       {
          continue;
       }
       if (itksys::SystemTools::FileIsDirectory(FullFilePath))
       {
          std::cout<<FullFilePath;
       }
    }
    
    return 0;
}